## hdf5-filter-plugin 0.0~git20221111.49e3b65

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(hdf5_filter_plugins
        LANGUAGES C CXX
        VERSION 0.1.0)
include(CTest)
include(CPackComponent)


#=============================================================================
# cached variables deciding which filter plugin to build
#=============================================================================

set(ENABLE_LZ4_PLUGIN OFF CACHE BOOL "Build LZ4 filter plugin")
set(ENABLE_BZIP2_PLUGIN OFF CACHE BOOL "Build BZIP2 filter plugin")
set(ENABLE_BITSHUFFLE_PLUGIN OFF CACHE BOOL "Build with BitShuffle plugin")

#
# add the global cmake directory to the module search path. Thus we can keep
# CMake code used by all plugins at a single location and avoid code
# duplications for the build system.
#
if(NOT DEFINED CMAKE_MODULE_PATH)
    message(STATUS "define an empty cmake module path")
    set(CMAKE_MODULE_PATH)
endif()
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#=============================================================================
# list with external libraries which must be installed 
#=============================================================================
set(EXTERNAL_LIBRARIES)

#=============================================================================
# if there is a conan file in the build directory we use conan to satisfy
# the build dependencies. This is currently not implemented.
#
# Using conan is particularly useful on Windows and OSX systems but can also 
# be useful on Linux systems where the required libraries are not available 
# from the distributions native package repositories. 
#
# Remark: if we use conan we have to ensure that all required shared 
#         libraries are copied to the install directory for OSX and Windows. 
#         For Linux we need to use RPATH for linking and copy the libraries
#         to a reasonable location according to the FHS (the same is true 
#         for all other Unix systems). 
#         As a matter of fact, as we do not install the modules in a directory
#         available to the system linker we can also copy all the dependencies
#         directly to the directory where the plugins will be installed. 
#=============================================================================
set(ENABLE_CONAN OFF CACHE BOOL "Enable dependency build with conan")

if(ENABLE_CONAN)
	include(cmake/ConanSetup.cmake)
	
    conan_cmake_run(CONANFILE conanfile.txt
    	            BASIC_SETUP
    	            BUILD missing)
endif()

if(ENABLE_LZ4_PLUGIN OR ENABLE_BITSHUFFLE_PLUGIN)
	include(cmake/ConfigureLZ4.cmake)

    if(CMAKE_SYSTEM_NAME MATCHES Windows)
        list(APPEND EXTERNAL_LIBRARIES ${PROJECT_BINARY_DIR}/bin/liblz4.dll)
    endif()
endif()

#=============================================================================
# some global configuration - check for things we need to build all the 
# filter plugins.
#=============================================================================

#
# For building the plugin modules we only need the header files. 
# However, for the tests we also need the library!
#
find_package(HDF5 REQUIRED COMPONENTS C) 

if(CMAKE_SYSTEM_NAME MATCHES Windows)
    add_definitions(-DH5_BUILT_AS_DYNAMIC_LIB)
    link_directories(${HDF5_LIBRARY_DIRS})

    list(APPEND EXTERNAL_LIBRARIES ${PROJECT_BINARY_DIR}/bin/zlib.dll
                                   ${PROJECT_BINARY_DIR}/bin/hdf5.dll
                                   ${PROJECT_BINARY_DIR}/bin/msvcp140.dll
                                   ${PROJECT_BINARY_DIR}/bin/vcruntime140.dll
                                   ${PROJECT_BINARY_DIR}/bin/hdf5_tools.dll
                                   )
endif()


#-----------------------------------------------------------------------------
# set the installation paths
#-----------------------------------------------------------------------------
if(CMAKE_SYSTEM_NAME MATCHES Windows)
    set(CMAKE_INSTALL_LIBDIR lib)
    set(CMAKE_INSTALL_PLUGINDIR ${CMAKE_INSTALL_LIBDIR}/plugins)
    set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ${CMAKE_INSTALL_PLUGINDIR})
   
    #ensure that runtime libraries are installed along with the plugins 
    include(InstallRequiredSystemLibraries)    
else()
    include(GNUInstallDirs)

    #
    # TODO: need to setup the installation directories for Linux and Unix
    #       systems
    #
    set(CMAKE_INSTALL_PLUGINDIR ${CMAKE_INSTALL_LIBDIR}/plugins)

endif()

#-----------------------------------------------------------------------------
# set the output path for build artifacts - should make testing simpler 
# (in particular when we want to test plugins simultaneously)
#-----------------------------------------------------------------------------
set(CMAKE_HDF5_PLUGIN_PATH ${PROJECT_BINARY_DIR}/plugins)

#=============================================================================
#add the subdirectories for the plugins to build
#=============================================================================
if(ENABLE_LZ4_PLUGIN)
    add_subdirectory(LZ4)
endif()

if(ENABLE_BZIP2_PLUGIN)
    add_subdirectory(BZIP2)
endif()

if(ENABLE_BITSHUFFLE_PLUGIN)
    add_subdirectory(bitshuffle)
endif()


#=============================================================================
# setting up the MSI build for Windows
#=============================================================================
if(CMAKE_SYSTEM_NAME MATCHES Windows)
    set(RESOURCE_DIR ${PROJECT_SOURCE_DIR}/resources)
    set(CPACK_GENERATOR WIX)
    set(CPACK_PACKAGE_VENDOR "HDFGroup")
    set(CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
    set(CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
    set(CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}")

    set(CPACK_RESOURCE_FILE_LICENSE "${RESOURCE_DIR}/LICENSE.txt")
    set(CPACK_WIX_PATCH_FILE "${PROJECT_SOURCE_DIR}/hdf5_plugin_path_patch.xml")

    install(FILES ${EXTERNAL_LIBRARIES} 
            DESTINATION ${CMAKE_INSTALL_PLUGINDIR})

    include(CPack)
    include(CPackWIX)
endif()

=== BLOSC/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.0)
project (H5BLOSC C CXX)

#-----------------------------------------------------------------------------
# Basic H5BLOSC stuff here
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
set (H5BLOSC_RESOURCES_DIR           ${H5BLOSC_SOURCE_DIR}/config/cmake)
set (HDF_RESOURCES_DIR               ${H5BLOSC_SOURCE_DIR}/config/cmake)
set (H5BLOSC_SRC_DIR                 ${H5BLOSC_SOURCE_DIR}/src)

#-----------------------------------------------------------------------------
# Set the core names of all the libraries
#-----------------------------------------------------------------------------
set (H5BLOSC_LIB_CORENAME              "h5blosc")

#-----------------------------------------------------------------------------
# Set the true names of all the libraries if customized by external project
#-----------------------------------------------------------------------------
set (H5BLOSC_LIB_NAME              "${H5BLOSC_EXTERNAL_LIB_PREFIX}${H5BLOSC_LIB_CORENAME}")

#-----------------------------------------------------------------------------
# Set the target names of all the libraries
#-----------------------------------------------------------------------------
set (H5BLOSC_LIB_TARGET              ${H5BLOSC_LIB_CORENAME})

if (NOT H5BLOSC_INSTALL_BIN_DIR)
  set (H5BLOSC_INSTALL_BIN_DIR bin)
endif (NOT H5BLOSC_INSTALL_BIN_DIR)
if (NOT H5BLOSC_INSTALL_LIB_DIR)
  set (H5BLOSC_INSTALL_LIB_DIR lib/plugin)
endif (NOT H5BLOSC_INSTALL_LIB_DIR)
if (NOT H5BLOSC_INSTALL_INCLUDE_DIR)
  set (H5BLOSC_INSTALL_INCLUDE_DIR include)
endif (NOT H5BLOSC_INSTALL_INCLUDE_DIR)
if (NOT H5BLOSC_INSTALL_DATA_DIR)
  if (NOT WIN32)
    set (H5BLOSC_INSTALL_DATA_DIR share)
    set (H5BLOSC_INSTALL_CMAKE_DIR share/cmake)
  else (NOT WIN32)
    set (H5BLOSC_INSTALL_DATA_DIR ".")
    set (H5BLOSC_INSTALL_CMAKE_DIR cmake)
  endif (NOT WIN32)
endif (NOT H5BLOSC_INSTALL_DATA_DIR)

set (H5BLOSC_VERS_MAJOR 3)
set (H5BLOSC_VERS_MINOR 1)
set (H5BLOSC_VERS_RELEASE 3)

set (H5BLOSC_SOVERS_MAJOR 3)
set (H5BLOSC_SOVERS_MINOR 1)
set (H5BLOSC_SOVERS_INTERFACE 3)
set (H5BLOSC_SOVERS_RELEASE 0)
math (EXPR H5BLOSC_SOVERS_MAJOR ${H5BLOSC_SOVERS_INTERFACE}-${H5BLOSC_SOVERS_RELEASE})

#-----------------------------------------------------------------------------
set (H5BLOSC_PACKAGE "h5blosc")
set (H5BLOSC_PACKAGE_NAME "h5blosc")
set (H5BLOSC_PACKAGE_VERSION "${H5BLOSC_VERS_MAJOR}.${H5BLOSC_VERS_MINOR}.${H5BLOSC_VERS_RELEASE}")
set (H5BLOSC_PACKAGE_VERSION_STRING "${H5BLOSC_PACKAGE_VERSION}")
set (H5BLOSC_PACKAGE_VERSION_MAJOR "${H5BLOSC_VERS_MAJOR}")
set (H5BLOSC_PACKAGE_VERSION_MINOR "${H5BLOSC_VERS_MINOR}")
set (H5BLOSC_PACKAGE_STRING "${H5BLOSC_PACKAGE_NAME} ${H5BLOSC_PACKAGE_VERSION}")
set (H5BLOSC_PACKAGE_TARNAME "${H5BLOSC_PACKAGE_NAME}{HDF_PACKAGE_EXT}")
set (H5BLOSC_PACKAGE_URL "http://www.hdfgroup.org")
set (H5BLOSC_PACKAGE_BUGREPORT "help@hdfgroup.org")
set (H5BLOSC_PACKAGE_SOVERSION "${H5BLOSC_SOVERS_MAJOR}.${H5BLOSC_SOVERS_RELEASE}.${H5BLOSC_SOVERS_MINOR}")

#-----------------------------------------------------------------------------
# Include some macros for reusable code
#-----------------------------------------------------------------------------
include (${H5BLOSC_RESOURCES_DIR}/H5BLOSCMacros.cmake)

#-----------------------------------------------------------------------------
# Setup output Directories
#-----------------------------------------------------------------------------
if (NOT H5BLOSC_EXTERNALLY_CONFIGURED)
  set (CMAKE_RUNTIME_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Executables."
  )
  set (CMAKE_LIBRARY_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Libraries"
  )
  set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all static libraries."
  )
else (NOT H5BLOSC_EXTERNALLY_CONFIGURED)
  # if we are externally configured, but the project uses old cmake scripts
  # this may not be set
  if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
  endif (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
endif (NOT H5BLOSC_EXTERNALLY_CONFIGURED)

#-----------------------------------------------------------------------------
# Targets built within this project are exported at Install time for use
# by other projects using FindH5BLOSC.
#-----------------------------------------------------------------------------
if (NOT H5BLOSC_EXPORTED_TARGETS)
  set (H5BLOSC_EXPORTED_TARGETS "H5blosc-targets")
endif (NOT H5BLOSC_EXPORTED_TARGETS)

#-----------------------------------------------------------------------------
# To include a library in the list exported by the project AT BUILD TIME,
# add it to this variable. This is NOT used by Make Install, but for projects
# which include h5blosc as a sub-project within their build tree
#-----------------------------------------------------------------------------
set_global_variable (H5BLOSC_LIBRARIES_TO_EXPORT "")

#-----------------------------------------------------------------------------
# Run all the CMake configuration tests for our build environment
#-----------------------------------------------------------------------------
include (${H5BLOSC_RESOURCES_DIR}/ConfigureChecks.cmake)

#-----------------------------------------------------------------------------
# Option to Build Shared/Static libs, only shared is allowed
#-----------------------------------------------------------------------------
option (BUILD_SHARED_LIBS "Build Shared Libraries" ON)
set (LIB_TYPE SHARED)
if (BUILD_SHARED_LIBS)
  set (LIB_TYPE SHARED)
  add_definitions (-DH5BLOSC_BUILT_AS_DYNAMIC_LIB)
else (BUILD_SHARED_LIBS)
  message (FATAL_ERROR " ${H5BLOSC_PACKAGE_NAME} library must be built as a shared library")
endif (BUILD_SHARED_LIBS)

#-----------------------------------------------------------------------------
# HDF5 support
#-----------------------------------------------------------------------------
set (CMAKE_MODULE_PATH ${HDF_RESOURCES_DIR} ${CMAKE_MODULE_PATH})

add_definitions (-DH5_USE_18_API)

if (NOT HDF5_HDF5_HEADER)
  if (USE_SHARED_LIBS)
    set (FIND_HDF_COMPONENTS C shared static)
  else (USE_SHARED_LIBS)
    set (FIND_HDF_COMPONENTS C static)
  endif (USE_SHARED_LIBS)
  message (STATUS "HDF5 find comps: ${FIND_HDF_COMPONENTS}")
  set (SEARCH_PACKAGE_NAME ${HDF5_PACKAGE_NAME})

  find_package (HDF5 NAMES ${SEARCH_PACKAGE_NAME} COMPONENTS ${FIND_HDF_COMPONENTS})
  message (STATUS "HDF5 C libs:${HDF5_FOUND} static:${HDF5_static_C_FOUND} and shared:${HDF5_shared_C_FOUND}")
  if (HDF5_FOUND)
    add_executable (h5repack IMPORTED)
    add_executable (h5dump IMPORTED)
    if (NOT HDF5_static_C_FOUND AND NOT HDF5_shared_C_FOUND)
      #find library from non-dual-binary package
      set (FIND_HDF_COMPONENTS C)
      message (STATUS "HDF5 find comps: ${FIND_HDF_COMPONENTS}")

      find_package (HDF5 NAMES ${SEARCH_PACKAGE_NAME} COMPONENTS ${FIND_HDF_COMPONENTS})
      message (STATUS "HDF5 libs:${HDF5_FOUND} C:${HDF5_C_FOUND}")
      set (HDF5_LINK_LIBS ${HDF5_LINK_LIBS} ${HDF5_LIBRARIES})
      #Blosc source needs to be linked with HDF5
      set (LINK_LIBS ${LINK_LIBS} ${HDF5_LIBRARIES})
      if (USE_SHARED_LIBS AND WIN32)
        set_property (TARGET h5repack PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5repackdll")
        set_property (TARGET h5dump PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5dumpdll")
      else (USE_SHARED_LIBS AND WIN32)
        set_property (TARGET h5repack PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5repack")
        set_property (TARGET h5dump PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5dump")
      endif (USE_SHARED_LIBS AND WIN32)
    else (NOT HDF5_static_C_FOUND AND NOT HDF5_shared_C_FOUND)
      if (USE_SHARED_LIBS AND HDF5_shared_C_FOUND)
        set (HDF5_LINK_LIBS ${HDF5_LINK_LIBS} ${HDF5_C_SHARED_LIBRARY})
      else (HDF5_static_C_FOUND)
        set (HDF5_LINK_LIBS ${HDF5_LINK_LIBS} ${HDF5_C_STATIC_LIBRARY})
      endif (USE_SHARED_LIBS AND HDF5_shared_C_FOUND)
      #Blosc source needs to be linked with HDF5
      set (LINK_LIBS ${LINK_LIBS} ${HDF5_C_SHARED_LIBRARY})
      set_property (TARGET h5repack PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5repack")
      set_property (TARGET h5dump PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5dump")
    endif (NOT HDF5_static_C_FOUND AND NOT HDF5_shared_C_FOUND)
    set (HDF5_DUMP_EXECUTABLE $<TARGET_FILE:h5dump>)
    set (HDF5_REPACK_EXECUTABLE $<TARGET_FILE:h5repack>)
  else (HDF5_FOUND)
    find_package (HDF5) # Legacy find
#Legacy find_package does not set HDF5_TOOLS_DIR, so we set it here
    set(HDF5_TOOLS_DIR ${HDF5_LIBRARY_DIRS}/../bin)
#Legacy find_package does not set HDF5_BUILD_SHARED_LIBS, so we set it here
    if (USE_SHARED_LIBS AND EXISTS "${HDF5_LIBRARY_DIRS}/libhdf5.so")
      set (HDF5_BUILD_SHARED_LIBS 1)
    else ()
      set (HDF5_BUILD_SHARED_LIBS 0)
    endif ()
    set (HDF5_LINK_LIBS ${HDF5_LINK_LIBS} ${HDF5_LIBRARIES})
    #Blosc source needs to be linked with HDF5
    set (LINK_LIBS ${LINK_LIBS} ${HDF5_LIBRARIES})

    add_executable (h5repack IMPORTED)
    add_executable (h5dump IMPORTED)
    set_property (TARGET h5dump PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5repack")
    set_property (TARGET h5dump PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5dump")
    set (HDF5_DUMP_EXECUTABLE $<TARGET_FILE:h5repack>)
    set (HDF5_DUMP_EXECUTABLE $<TARGET_FILE:h5dump>)
  endif (HDF5_FOUND)
  set (HDF5_PACKAGE_NAME ${SEARCH_PACKAGE_NAME})

  if (HDF5_FOUND)
    set (HDF5_HAVE_H5PUBCONF_H 1)
    set (HDF5_HAVE_HDF5 1)
    set (HDF5_HDF5_HEADER "h5pubconf.h")
    set (HDF5_INCLUDE_DIR_GEN ${HDF5_INCLUDE_DIR})
    message (STATUS "HDF5 found: INC=${HDF5_INCLUDE_DIR} TOOLS=${HDF5_TOOLS_DIR}")
  else (HDF5_FOUND)
    message (FATAL_ERROR " HDF5 is Required for ${H5BLOSC_PACKAGE_NAME} library")
  endif (HDF5_FOUND)
else (NOT HDF5_HDF5_HEADER)
  # This project is being called from within another and HDF5 is already configured
  set (HDF5_HAVE_H5PUBCONF_H 1)
  set (HDF5_HAVE_HDF5 1)
endif (NOT HDF5_HDF5_HEADER)
message (STATUS "HDF5 link libs: ${HDF5_LINK_LIBS}")

if (USE_SHARED_LIBS)
  set (H5_LIB_TYPE SHARED)
else (USE_SHARED_LIBS)
  set (H5_LIB_TYPE STATIC)
endif (USE_SHARED_LIBS)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
if(WIN32)
    # try to use the system library
    find_package(Threads)
    if(Threads_FOUND)
        set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
    endif(Threads_FOUND)
else(WIN32)
    find_package(Threads REQUIRED)
    set(LINK_LIBS ${LINK_LIBS} ${CMAKE_THREAD_LIBS_INIT})
endif(WIN32)

option(PREFER_EXTERNAL_COMPLIBS
    "When found, use the installed compression libs instead of included sources." ON)
if(NOT PREFER_EXTERNAL_COMPLIBS)
    message(STATUS "Finding external libraries disabled.  Using internal sources.")
endif(NOT PREFER_EXTERNAL_COMPLIBS)

option(DEACTIVATE_LZ4
    "Do not include support for the LZ4 library." OFF)
if(NOT DEACTIVATE_LZ4)
    if(PREFER_EXTERNAL_COMPLIBS)
        find_package(LZ4)
    endif(PREFER_EXTERNAL_COMPLIBS)
    # HAVE_LZ4 will be set to true because even if the library is
    # not found, we will use the included sources for it
    set(HAVE_LZ4 TRUE)
endif(NOT DEACTIVATE_LZ4)

option(DEACTIVATE_SNAPPY
    "Do not include support for the SNAPPY library." OFF)
if(NOT DEACTIVATE_SNAPPY)
    if(PREFER_EXTERNAL_COMPLIBS)
        find_package(Snappy)
    endif(PREFER_EXTERNAL_COMPLIBS)
    # HAVE_SNAPPY will be set to true because even if the library is not found,
    # we will use the included sources for it
    set(HAVE_SNAPPY TRUE)
endif(NOT DEACTIVATE_SNAPPY)

option(DEACTIVATE_ZLIB
    "Do not include support for the ZLIB library." OFF)

=== BZIP2/CMakeLists.txt ===

#=============================================================================
# do some plugin specific configuration
#=============================================================================
find_package(BZip2 REQUIRED)

if(CMAKE_SYSTEM_NAME MATCHES Windows)
    set(EXTERNAL_LIBRARIES ${PROJECT_BINARY_DIR}/bin/bz2.dll)
endif()

#=============================================================================
# setup the plugin name
#=============================================================================
set(PLUGIN_NAME h5bz2)

#=============================================================================
# adding required subdirectories
#=============================================================================
add_subdirectory(src)
add_subdirectory(test)

=== LZ4/CMakeLists.txt ===
message(STATUS "Building with LZ4 plugin")

#==============================================================================
# set the plugin name
#==============================================================================
set(PLUGIN_NAME hdf5lz4)

#==============================================================================
# add source directories
#==============================================================================
add_subdirectory(src)
add_subdirectory(test)

=== bitshuffle/CMakeLists.txt ===

add_subdirectory(src)
add_subdirectory(test)

=== docs/Makefile ===
master_src := techrequirements.tex
document := $(master_src:.tex=.pdf)
auxfile := $(master_src:.tex=.aux)
bibliography := references.bib

all: $(document)

$(document): $(master_src) $(bibliography)
	pdflatex $(master_src)
	bibtex $(auxfile)
	pdflatex $(master_src)
	pdflatex $(master_src)

.PHONY: clean all

clean:
	rm -rf $(document)
	rm -rf $(auxfile)

=== BLOSC/example/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
project (HDF5BLOSC_EX)

set (dyn_examples
    h5ex_d_blosc
)

if (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_DYNAMIC_LIB)
else (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_STATIC_LIB)
endif (USE_SHARED_LIBS)

#run-time loadable blosc library examples
foreach (example ${dyn_examples})
  add_executable (${example} ${PROJECT_SOURCE_DIR}/${example}.c)
  TARGET_NAMING (${example} ${LIB_TYPE})
  TARGET_C_PROPERTIES (${example} ${LIB_TYPE} " " " ")
  target_link_libraries (${example} ${HDF5_LINK_LIBS})
  if (NOT WIN32)
    target_link_libraries (${example} dl)
  endif (NOT WIN32)
endforeach (example ${dyn_examples})

if (BUILD_TESTING)
  MACRO (ADD_H5_TEST testname)
    add_test (
        NAME ${testname}-clearall
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${testname}.out
            ${testname}.out.err
            ${testname}.ddl.out
            ${testname}.ddl.out.err
            ${testname}.h5
    )
    add_test (
        NAME ${testname}
        COMMAND "${CMAKE_COMMAND}"
            -D "TEST_PROGRAM=$<TARGET_FILE:${testname}>"
            -D "TEST_ARGS:STRING=${ARGN}"
            -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
            -D "TEST_EXPECT=0"
            -D "TEST_OUTPUT=${testname}.out"
            -D "TEST_REFERENCE=${testname}.tst"
            -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
            -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
            -P "${H5BLOSC_RESOURCES_DIR}/runTest.cmake"
    )
    set_tests_properties(${testname} PROPERTIES DEPENDS ${testname}-clearall)
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5DUMP-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=--enable-error-stack;${testname}.h5"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${testname}.ddl.out"
              -D "TEST_EXPECT=0"
              -D "TEST_REFERENCE=${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BLOSC_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties(H5DUMP-${testname} PROPERTIES DEPENDS ${testname})
    endif (HDF5_BUILD_TOOLS)
  ENDMACRO (ADD_H5_TEST)

  MACRO (ADD_H5_UD_TEST testname resultcode resultfile)
    # Remove any output file left over from previous test run
    add_test (
        NAME H5BLOSC_UD-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            out-${testname}.${resultfile}
            ${testname}.${resultfile}.out
            ${testname}.${resultfile}.out.err
            ${resultfile}-${testname}.out
            ${resultfile}-${testname}.out.err
    )
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5BLOSC_UD-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5repack>"
              -D "TEST_ARGS:STRING=${ARGN};${PROJECT_BINARY_DIR}/${resultfile};${PROJECT_BINARY_DIR}/out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_FILTER:STRING=O?...ing file[^\n]+\n"
              -D "TEST_OUTPUT=${testname}.${resultfile}.out"
              -D "TEST_REFERENCE=${testname}.${resultfile}.tst"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BLOSC_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5BLOSC_UD-${testname} PROPERTIES DEPENDS H5BLOSC_UD-clearall-objects)
      add_test (
          NAME H5BLOSC_UD-h5dump-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=-pH;out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${resultfile}-${testname}.out"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_REFERENCE=${resultfile}-${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BLOSC_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5BLOSC_UD-h5dump-${testname} PROPERTIES DEPENDS "H5BLOSC_UD-${testname}")
    endif (HDF5_BUILD_TOOLS)
  endmacro (ADD_H5_UD_TEST)

  # --------------------------------------------------------------------
  # Copy all the HDF5 files from the source directory into the test directory
  # --------------------------------------------------------------------
  set (LIST_HDF5_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5
  )
  set (LIST_OTHER_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_blosc.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_blosc.tst
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5-ud_convert.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/ud_convert.h5repack_layout.h5.tst
  )

  foreach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
    get_filename_component(fname "${h5_file}" NAME)
    set (dest "${PROJECT_BINARY_DIR}/${fname}")
    #message (STATUS " Copying ${h5_file}")
    add_custom_command (
        TARGET     h5ex_d_blosc
        POST_BUILD
        COMMAND    ${CMAKE_COMMAND}
        ARGS       -E copy_if_different ${h5_file} ${dest}
    )
  endforeach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
#  if (WIN32 AND ${H5_LIB_TYPE} MATCHES "SHARED")
#    set (outdir "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
#    if (MINGW)
#      set (outname "${BLOSC_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
#    else (MINGW)
#      set (outdir "${outdir}/${CMAKE_BUILD_TYPE}")
#      set (outname "${CMAKE_SHARED_LIBRARY_PREFIX}${BLOSC_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
#    endif (MINGW)
#    add_custom_command (
#        TARGET     h5ex_d_blosc
#        POST_BUILD
#        COMMAND    ${CMAKE_COMMAND}
#        ARGS       -E copy_if_different ${outdir}/${outname} ${PROJECT_BINARY_DIR}/${outname}
#    )
#  endif (WIN32 AND ${H5_LIB_TYPE} MATCHES "SHARED")

  ADD_H5_TEST (h5ex_d_blosc)

#UD BLOSC
#  ADD_H5_UD_TEST (ud_convert 0 h5repack_layout.h5 -v -f UD=32001,1,...,n)

endif (BUILD_TESTING)

=== BLOSC/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
project (H5BLOSC_SRC C CXX)

set(INTERNAL_LIBS ${H5BLOSC_SRC_SOURCE_DIR}/internal-complibs)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
INCLUDE_DIRECTORIES (${H5BLOSC_SRC_SOURCE_DIR})
INCLUDE_DIRECTORIES (${CMAKE_BINARY_DIR})

if (BLOSC_FOUND)
    include_directories( ${BLOSC_INCLUDE_DIR} )
else(BLOSC_FOUND)
    set(BLOSC_LOCAL_DIR ${INTERNAL_LIBS}/blosc-1.4.1)
    include_directories( ${BLOSC_LOCAL_DIR} )
endif(BLOSC_FOUND)

if(NOT DEACTIVATE_LZ4)
    if (LZ4_FOUND)
        include_directories( ${LZ4_INCLUDE_DIR} )
    else(LZ4_FOUND)
        set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-r119)
        include_directories( ${LZ4_LOCAL_DIR} )
    endif(LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if (SNAPPY_FOUND)
        include_directories( ${SNAPPY_INCLUDE_DIR} )
    else(SNAPPY_FOUND)
        set(SNAPPY_LOCAL_DIR ${INTERNAL_LIBS}/snappy-1.1.1)
        include_directories( ${SNAPPY_LOCAL_DIR} )
    endif(SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if (ZLIB_FOUND)
        include_directories( ${ZLIB_INCLUDE_DIR} )
    else(ZLIB_FOUND)
        set(ZLIB_LOCAL_DIR ${INTERNAL_LIBS}/zlib-1.2.8)
        include_directories( ${ZLIB_LOCAL_DIR} )
    endif(ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

#-----------------------------------------------------------------------------
# Apply Definitions to compiler in this directory and below
#-----------------------------------------------------------------------------
add_definitions (${HDF5_EXTRA_C_FLAGS})

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
INCLUDE_DIRECTORIES (${HDF5_INCLUDE_DIR})

#-----------------------------------------------------------------------------
# Define H5BLOSC Library
#-----------------------------------------------------------------------------
set (H5BLOSC_SRCS
    ${H5BLOSC_SRC_SOURCE_DIR}/H5Zblosc.c
)

if(WIN32)
  if(NOT Threads_FOUND)
    message(STATUS "using the internal pthread library for win32 systems.")
    set(H5BLOSC_SRCS ${H5BLOSC_SRCS} win32/pthread.c)
  endif(NOT Threads_FOUND)
endif(WIN32)

if(NOT BLOSC_FOUND)
    set(BLOSC_FILES 
        ${BLOSC_LOCAL_DIR}/blosc.c 
        ${BLOSC_LOCAL_DIR}/blosclz.c 
        ${BLOSC_LOCAL_DIR}/shuffle.c
    )
    set(H5BLOSC_SRCS ${H5BLOSC_SRCS} ${BLOSC_FILES})
endif(NOT BLOSC_FOUND)

if(NOT DEACTIVATE_LZ4)
    if(NOT LZ4_FOUND)
        set(LZ4_FILES
            ${LZ4_LOCAL_DIR}/lz4.c
            ${LZ4_LOCAL_DIR}/lz4hc.c
        )
        set(H5BLOSC_SRCS ${H5BLOSC_SRCS} ${LZ4_FILES})
    endif(NOT LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if(NOT SNAPPY_FOUND)
        set(SNAPPY_FILES
            ${SNAPPY_LOCAL_DIR}/snappy.cc
            ${SNAPPY_LOCAL_DIR}/snappy-c.cc
            ${SNAPPY_LOCAL_DIR}/snappy-sinksource.cc
            ${SNAPPY_LOCAL_DIR}/snappy-stubs-internal.cc
        )
        set(H5BLOSC_SRCS ${H5BLOSC_SRCS} ${SNAPPY_FILES})
    endif(NOT SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if(NOT ZLIB_FOUND)
        set(ZLIB_FILES
            ${ZLIB_LOCAL_DIR}/adler32.c
            ${ZLIB_LOCAL_DIR}/crc32.c
            ${ZLIB_LOCAL_DIR}/deflate.c
            ${ZLIB_LOCAL_DIR}/gzclose.c
            ${ZLIB_LOCAL_DIR}/gzlib.c
            ${ZLIB_LOCAL_DIR}/gzread.c
            ${ZLIB_LOCAL_DIR}/gzwrite.c
            ${ZLIB_LOCAL_DIR}/infback.c
            ${ZLIB_LOCAL_DIR}/inffast.c
            ${ZLIB_LOCAL_DIR}/inflate.c
            ${ZLIB_LOCAL_DIR}/inftrees.c
            ${ZLIB_LOCAL_DIR}/trees.c
            ${ZLIB_LOCAL_DIR}/uncompr.c
            ${ZLIB_LOCAL_DIR}/zutil.c
        )
        set(H5BLOSC_SRCS ${H5BLOSC_SRCS} ${ZLIB_FILES})
    endif(NOT ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

add_library (${H5BLOSC_LIB_TARGET} ${LIB_TYPE} ${H5BLOSC_SRCS})
target_link_libraries (${H5BLOSC_LIB_TARGET} ${LINK_LIBS})
#if (NOT USE_SHARED_LIBS)
#  target_link_libraries (${H5BLOSC_LIB_TARGET} ${HDF5_LIBRARIES})
#endif (NOT USE_SHARED_LIBS)
SET_GLOBAL_VARIABLE (H5BLOSC_LIBRARIES_TO_EXPORT ${H5BLOSC_LIB_TARGET})
H5BLOSC_SET_LIB_OPTIONS (${H5BLOSC_LIB_TARGET} ${H5BLOSC_LIB_NAME} ${LIB_TYPE})

if (BUILD_TESTING)
  #-----------------------------------------------------------------------------
  # Copy plugin library to a plugins folder
  #-----------------------------------------------------------------------------

  # make plugins dir
  file (MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/plugins")
  add_custom_command (
      TARGET     ${H5BLOSC_LIB_TARGET}
      POST_BUILD
      COMMAND    ${CMAKE_COMMAND}
      ARGS       -E copy_if_different 
        "$<TARGET_FILE:${H5BLOSC_LIB_TARGET}>"
        "${CMAKE_BINARY_DIR}/plugins/$<TARGET_FILE_NAME:${H5BLOSC_LIB_TARGET}>"
  )
endif (BUILD_TESTING)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
if (H5BLOSC_EXPORTED_TARGETS)
  install (
      TARGETS
          ${H5BLOSC_LIB_TARGET}
      EXPORT
          ${H5BLOSC_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${H5BLOSC_INSTALL_LIB_DIR} COMPONENT libraries
      ARCHIVE DESTINATION ${H5BLOSC_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${H5BLOSC_INSTALL_BIN_DIR} COMPONENT libraries
  )
endif (H5BLOSC_EXPORTED_TARGETS)

=== BZIP2/example/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.0)
project (HDF5BZ2_EX)

set (dyn_examples
    h5ex_d_bzip2
)

if (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_DYNAMIC_LIB)
else (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_STATIC_LIB)
endif (USE_SHARED_LIBS)

#run-time loadable bzip library examples
foreach (example ${dyn_examples})
  add_executable (${example} ${PROJECT_SOURCE_DIR}/${example}.c)
  TARGET_NAMING (${example} ${LIB_TYPE})
  TARGET_C_PROPERTIES (${example} ${LIB_TYPE} " " " ")
  target_link_libraries (${example} ${HDF5_LINK_LIBS})
  if (NOT WIN32)
    target_link_libraries (${example} dl)
  endif (NOT WIN32)
endforeach (example ${dyn_examples})

if (BUILD_TESTING)
  MACRO (ADD_H5_TEST testname)
    add_test (
        NAME ${testname}-clearall
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${testname}.out
            ${testname}.out.err
            ${testname}.ddl.out
            ${testname}.ddl.out.err
            ${testname}.h5
    )
    add_test (
        NAME ${testname}
        COMMAND "${CMAKE_COMMAND}"
            -D "TEST_PROGRAM=$<TARGET_FILE:${testname}>"
            -D "TEST_ARGS:STRING=${ARGN}"
            -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
            -D "TEST_EXPECT=0"
            -D "TEST_OUTPUT=${testname}.out"
            -D "TEST_REFERENCE=${testname}.tst"
            -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
            -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
            -P "${H5BZ2_RESOURCES_DIR}/runTest.cmake"
    )
    set_tests_properties(${testname} PROPERTIES DEPENDS ${testname}-clearall)
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5DUMP-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=--enable-error-stack;${testname}.h5"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${testname}.ddl.out"
              -D "TEST_EXPECT=0"
              -D "TEST_REFERENCE=${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BZ2_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties(H5DUMP-${testname} PROPERTIES DEPENDS ${testname})
    endif (HDF5_BUILD_TOOLS)
  ENDMACRO (ADD_H5_TEST)

  MACRO (ADD_H5_UD_TEST testname resultcode resultfile)
    # Remove any output file left over from previous test run
    add_test (
        NAME H5BZ2_UD-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            out-${testname}.${resultfile}
            ${testname}.${resultfile}.out
            ${testname}.${resultfile}.out.err
            ${resultfile}-${testname}.out
            ${resultfile}-${testname}.out.err
    )
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5BZ2_UD-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5repack>"
              -D "TEST_ARGS:STRING=${ARGN};${PROJECT_BINARY_DIR}/${resultfile};${PROJECT_BINARY_DIR}/out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_FILTER:STRING=O?...ing file[^\n]+\n"
              -D "TEST_OUTPUT=${testname}.${resultfile}.out"
              -D "TEST_REFERENCE=${testname}.${resultfile}.tst"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BZ2_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5BZ2_UD-${testname} PROPERTIES DEPENDS H5BZ2_UD-clearall-objects)
      add_test (
          NAME H5BZ2_UD-h5dump-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=-pH;out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${resultfile}-${testname}.out"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_REFERENCE=${resultfile}-${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5BZ2_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5BZ2_UD-h5dump-${testname} PROPERTIES DEPENDS "H5BZ2_UD-${testname}")
    endif (HDF5_BUILD_TOOLS)
  endmacro (ADD_H5_UD_TEST)

  # --------------------------------------------------------------------
  # Copy all the HDF5 files from the source directory into the test directory
  # --------------------------------------------------------------------
  set (LIST_HDF5_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5
  )
  set (LIST_OTHER_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_bzip2.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_bzip2.tst
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5-ud_convert.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/ud_convert.h5repack_layout.h5.tst
  )

  foreach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
    get_filename_component(fname "${h5_file}" NAME)
    set (dest "${PROJECT_BINARY_DIR}/${fname}")
    #message (STATUS " Copying ${h5_file}")
    add_custom_command (
        TARGET     h5ex_d_bzip2
        POST_BUILD
        COMMAND    ${CMAKE_COMMAND}
        ARGS       -E copy_if_different ${h5_file} ${dest}
    )
  endforeach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
  if (WIN32 AND ${H5_LIB_TYPE} MATCHES "SHARED")
    set (outdir "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
    if (MINGW)
      set (outname "${BZ2_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    else (MINGW)
      set (outdir "${outdir}/${CMAKE_BUILD_TYPE}")
      set (outname "${CMAKE_SHARED_LIBRARY_PREFIX}${BZ2_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (MINGW)
    add_custom_command (
        TARGET     h5ex_d_bzip2
        POST_BUILD
        COMMAND    ${CMAKE_COMMAND}
        ARGS       -E copy_if_different ${outdir}/${outname} ${PROJECT_BINARY_DIR}/${outname}
    )
  endif (WIN32 AND ${H5_LIB_TYPE} MATCHES "SHARED")

  ADD_H5_TEST (h5ex_d_bzip2)

#UD BZIP2
  ADD_H5_UD_TEST (ud_convert 0 h5repack_layout.h5 -v -f UD=307,1,9)

endif (BUILD_TESTING)

=== BZIP2/src/CMakeLists.txt ===
add_library(bz2_plugin MODULE H5Zbzip2.c)
target_include_directories(bz2_plugin PRIVATE
    ${BZIP2_INCLUDE_DIR} ${HDF5_INCLUDE_DIRS})
target_link_libraries(bz2_plugin PRIVATE
    ${BZIP2_LIBRARIES})
set_target_properties(bz2_plugin PROPERTIES 
    OUTPUT_NAME ${PLUGIN_NAME}
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_HDF5_PLUGIN_PATH}
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_HDF5_PLUGIN_PATH}
    LIBRARY_OUTPUT_DIRECTORY_DEBUG ${CMAKE_HDF5_PLUGIN_PATH}
    LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_HDF5_PLUGIN_PATH}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_HDF5_PLUGIN_PATH}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_HDF5_PLUGIN_PATH}
    )

install(TARGETS bz2_plugin
        DESTINATION ${CMAKE_INSTALL_PLUGINDIR})

=== BZIP2/test/CMakeLists.txt ===
set(datafiles ui8_data.h5)

foreach(datafile ${datafiles})
    configure_file(${datafile} ${datafile} COPYONLY)
endforeach()

#=============================================================================
# original test program provided by the HDF group
#=============================================================================
add_executable(bz2_plugin_prg1 h5ex_d_bzip2.c)
target_include_directories(bz2_plugin_prg1 PRIVATE ${HDF5_INCLUDE_DIRS})
target_link_libraries(bz2_plugin_prg1 PRIVATE ${HDF5_LIBRARIES})

add_test(NAME "HDF5:external_filters:bzip2"
         COMMAND bz2_plugin_prg1
         WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/BZIP2/test)
set_tests_properties("HDF5:external_filters:bzip2"
                     PROPERTIES
                     ENVIRONMENT
                     "HDF5_PLUGIN_PATH=$<TARGET_FILE_DIR:bz2_plugin>")


#=============================================================================
# new test program performing read-back tests. The data is generated with 
# PyTables which has support for BZIP2 compression included!
#=============================================================================
add_executable(read_ui8_test read_ui8_test.c)
target_include_directories(read_ui8_test PRIVATE ${HDF5_INCLUDE_DIRS})
target_link_libraries(read_ui8_test PRIVATE ${HDF5_LIBRARIES})

add_test(NAME "HDF5:external_filters:bipz2_read_ui8"
         COMMAND read_ui8_test
         WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/BZIP2/test)
set_tests_properties("HDF5:external_filters:bipz2_read_ui8"
                     PROPERTIES
                     ENVIRONMENT
                     "HDF5_PLUGIN_PATH=$<TARGET_FILE_DIR:bz2_plugin>")

=== LZ4/example/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1.0)
project (HDF5LZ4_EX)

set (dyn_examples
    h5ex_d_lz4
)

if (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_DYNAMIC_LIB)
else (USE_SHARED_LIBS)
  add_definitions (-DH5_BUILT_AS_STATIC_LIB)
endif (USE_SHARED_LIBS)

#run-time loadable lz4 library examples
foreach (example ${dyn_examples})
  add_executable (${example} ${PROJECT_SOURCE_DIR}/${example}.c)
  TARGET_NAMING (${example} ${LIB_TYPE})
  TARGET_C_PROPERTIES (${example} ${LIB_TYPE} " " " ")
  target_link_libraries (${example} ${HDF5_LINK_LIBS})
  if (NOT WIN32)
    target_link_libraries (${example} dl)
  endif (NOT WIN32)
endforeach (example ${dyn_examples})

if (BUILD_TESTING)
  MACRO (ADD_H5_TEST testname)
    add_test (
        NAME ${testname}-clearall
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${testname}.out
            ${testname}.out.err
            ${testname}.ddl.out
            ${testname}.ddl.out.err
            ${testname}.h5
    )
    add_test (
        NAME ${testname}
        COMMAND "${CMAKE_COMMAND}"
            -D "TEST_PROGRAM=$<TARGET_FILE:${testname}>"
            -D "TEST_ARGS:STRING=${ARGN}"
            -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
            -D "TEST_EXPECT=0"
            -D "TEST_OUTPUT=${testname}.out"
            -D "TEST_REFERENCE=${testname}.tst"
            -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
            -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
            -P "${H5LZ4_RESOURCES_DIR}/runTest.cmake"
    )
    set_tests_properties(${testname} PROPERTIES DEPENDS ${testname}-clearall)
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5DUMP-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=--enable-error-stack;${testname}.h5"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${testname}.ddl.out"
              -D "TEST_EXPECT=0"
              -D "TEST_REFERENCE=${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5LZ4_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties(H5DUMP-${testname} PROPERTIES DEPENDS ${testname})
    endif (HDF5_BUILD_TOOLS)
  ENDMACRO (ADD_H5_TEST)

  MACRO (ADD_H5_UD_TEST testname resultcode resultfile)
    # Remove any output file left over from previous test run
    add_test (
        NAME H5LZ4_UD-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            out-${testname}.${resultfile}
            ${testname}.${resultfile}.out
            ${testname}.${resultfile}.out.err
            ${resultfile}-${testname}.out
            ${resultfile}-${testname}.out.err
    )
    if (HDF5_BUILD_TOOLS)
      add_test (
          NAME H5LZ4_UD-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5repack>"
              -D "TEST_ARGS:STRING=${ARGN};${PROJECT_BINARY_DIR}/${resultfile};${PROJECT_BINARY_DIR}/out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_FILTER:STRING=O?...ing file[^\n]+\n"
              -D "TEST_OUTPUT=${testname}.${resultfile}.out"
              -D "TEST_REFERENCE=${testname}.${resultfile}.tst"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5LZ4_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5LZ4_UD-${testname} PROPERTIES DEPENDS H5LZ4_UD-clearall-objects)
      add_test (
          NAME H5LZ4_UD-h5dump-${testname}
          COMMAND "${CMAKE_COMMAND}"
              -D "TEST_PROGRAM=$<TARGET_FILE:h5dump>"
              -D "TEST_ARGS:STRING=-pH;out-${testname}.${resultfile}"
              -D "TEST_FOLDER=${PROJECT_BINARY_DIR}"
              -D "TEST_OUTPUT=${resultfile}-${testname}.out"
              -D "TEST_EXPECT=${resultcode}"
              -D "TEST_REFERENCE=${resultfile}-${testname}.ddl"
              -D "TEST_ENV_VAR=HDF5_PLUGIN_PATH"
              -D "TEST_ENV_VALUE=${CMAKE_BINARY_DIR}/plugins"
              -P "${H5LZ4_RESOURCES_DIR}/runTest.cmake"
      )
      set_tests_properties (H5LZ4_UD-h5dump-${testname} PROPERTIES DEPENDS "H5LZ4_UD-${testname}")
    endif (HDF5_BUILD_TOOLS)
  endmacro (ADD_H5_UD_TEST)

  # --------------------------------------------------------------------
  # Copy all the HDF5 files from the source directory into the test directory
  # --------------------------------------------------------------------
  set (LIST_HDF5_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5
  )
  set (LIST_OTHER_TEST_FILES
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_lz4.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/h5ex_d_lz4.tst
      ${PROJECT_SOURCE_DIR}/testfiles/h5repack_layout.h5-ud_convert.ddl
      ${PROJECT_SOURCE_DIR}/testfiles/ud_convert.h5repack_layout.h5.tst
  )

  foreach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
    get_filename_component(fname "${h5_file}" NAME)
    set (dest "${PROJECT_BINARY_DIR}/${fname}")
    #message (STATUS " Copying ${h5_file}")
    add_custom_command (
        TARGET     h5ex_d_lz4
        POST_BUILD
        COMMAND    ${CMAKE_COMMAND}
        ARGS       -E copy_if_different ${h5_file} ${dest}
    )
  endforeach (h5_file ${LIST_HDF5_TEST_FILES} ${LIST_OTHER_TEST_FILES})
  if (WIN32 AND NOT BUILD_LZ4_LIBRARY_SOURCE AND ${H5_LIB_TYPE} MATCHES "SHARED")
    set (outdir "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
    if (MINGW)
      set (outname "${LZ4_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    else (MINGW)
      set (outdir "${outdir}/${CMAKE_BUILD_TYPE}")
      set (outname "${CMAKE_SHARED_LIBRARY_PREFIX}${LZ4_LIBRARIES}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (MINGW)
    add_custom_command (
        TARGET     h5ex_d_lz4
        POST_BUILD
        COMMAND    ${CMAKE_COMMAND}
        ARGS       -E copy_if_different ${outdir}/${outname} ${PROJECT_BINARY_DIR}/${outname}
    )
  endif (WIN32 AND NOT BUILD_LZ4_LIBRARY_SOURCE AND ${H5_LIB_TYPE} MATCHES "SHARED")

  ADD_H5_TEST (h5ex_d_lz4)

#UD LZ$
  ADD_H5_UD_TEST (ud_convert 0 h5repack_layout.h5 -v -f UD=32004,2,32,0)

endif (BUILD_TESTING)

=== debian/changelog ===
hdf5-filter-plugin (0.0~git20221111.49e3b65-6) unstable; urgency=medium

  * Team upload.
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (closes: #1112987).
  * Build-depend on pkgconf rather than pkg-config.

 -- Colin Watson <cjwatson@debian.org>  Sun, 28 Sep 2025 13:43:43 +0100

hdf5-filter-plugin (0.0~git20221111.49e3b65-5) unstable; urgency=medium

  * Remove bitshuffle from the package short description too.

 -- Roland Mas <lolando@debian.org>  Sun, 16 Mar 2025 13:44:39 +0100

hdf5-filter-plugin (0.0~git20221111.49e3b65-4) unstable; urgency=medium

  * Removed mention of bitshuffle from package description
  * Provides: hdf5-filter-plugin-bz2-serial, hdf5-filter-plugin-lz4-serial
    to follow https://salsa.debian.org/science-team/h5f-packaging-guidelines
  * Added simple autopkgtests
  * Moved project to science-team group, updated Vcs-* headers accordingly

 -- Enrico Zini <enrico@debian.org>  Sun, 29 Jan 2023 11:56:33 +0100

hdf5-filter-plugin (0.0~git20221111.49e3b65-3) unstable; urgency=medium

  [ Enrico Zini ]
  * Disable building the bitshuffle plugin (Closes: #1025391)
  * Added patch to link against hdf5 (Closes: #1025686)

  [ Thorsten Alteholz ]
  * debian/control: Maintainer: set to Freexian, moved myself to Uploaders:

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 17 Dec 2022 17:07:18 +0100

hdf5-filter-plugin (0.0~git20221111.49e3b65-2) unstable; urgency=medium

  * adapt install path of plugin (Closes: #1024804)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 28 Nov 2022 19:07:18 +0100

hdf5-filter-plugin (0.0~git20221111.49e3b65-1) unstable; urgency=medium

  * New upstream release.
    (all patches applied upstream)

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 18 Nov 2022 18:17:18 +0000

=== debian/control ===
Source: hdf5-filter-plugin
Priority: optional
Section: science
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, libhdf5-dev
	, liblz4-dev
	, libbz2-dev
	, pkgconf
Homepage: https://github.com/nexusformat/HDF5-External-Filter-Plugins
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/hdf5-filter-plugin
Vcs-Git: https://salsa.debian.org/science-team/hdf5-filter-plugin.git

Package: hdf5-filter-plugin
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: hdf5-filter-plugin-bz2-serial, hdf5-filter-plugin-lz4-serial
Multi-Arch: foreign
Description: external filters for HDF5: LZ4, BZip2
 The external filter mechanism introduced with HDF5 1.8.12 allows
 applications to utilize custom filters not shipped by the HDF5
 core library without recompiling your application. This package
 provides external filters for HDF5 for
 .
  - the LZ4 compression algorithm
  - BZip2 compression

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PLUGIN_DIR=$(shell $(PKG_CONFIG) hdf5-serial  --variable=PluginDir|sed "s?/plugins??")

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DENABLE_LZ4_PLUGIN=yes \
		-DENABLE_BZIP2_PLUGIN=yes \
		-DCMAKE_INSTALL_LIBDIR=${PLUGIN_DIR}

override_dh_auto_install:
	dh_auto_install --destdir=debian/hdf5-filter-plugin/
	find

=== debian/tests/control ===
Test-Command: python3 -c 'import sys, h5py; sys.exit(not h5py.h5z.filter_avail(307))'
Depends: python3, python3-h5py, @
Restrictions: allow-stderr

Test-Command: python3 -c 'import sys, h5py; sys.exit(not h5py.h5z.filter_avail(32004))'
Depends: python3, python3-h5py, @
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
  https://github.com/nexusformat/HDF5-External-Filter-Plugins \
  HEAD debian uupdate
